<template>
    
    <v-row justify="center">
        <v-dialog
        v-model="dialogBox"
        max-width="450"
        >
            <v-card>

                <div v-if="codeBar">
                    <StreamBarcodeReader
                        @decode="(a, b, c) => onDecode(a, b, c)"
                        @loaded="() => onLoaded()"
                    ></StreamBarcodeReader>
                </div>
                <v-card-title class="text-h5">
                    {{modeBox == 0 ? 'Añadir Caja' : 'Añadir tubo'}} 
                </v-card-title>
                <v-card-text>
                    <v-alert
                        text
                    >
                        <v-row>
                            <v-col cols="6">
                                Alto = {{boxHeight*100+10}}
                            </v-col>
                            <v-col cols="6">
                                Ancho = {{boxWidth}}
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col cols="6">
                                Largo = {{boxLong}}
                            </v-col>
                            <v-col cols="6">
                                Peso = {{boxWeight}}
                            </v-col>
                        </v-row>
                    </v-alert>
                    <v-spacer></v-spacer>
                    <v-data-table
                        :headers="headers"
                        :items="arrayCodes"
                        :footer-props="{ disablePagination : true, disableItemsPerPage : true }"
                        :disable-sort="true"
                        hide-default-footer
                    >

                    </v-data-table>
                    <v-text-field
                        label="Peso [kg]"
                        v-model="boxWeight"
                    >
                    </v-text-field>
                    <v-spacer></v-spacer>
                    <v-btn
                        color="green darken-1"
                        text
                        @click="codeBar = true"
                    >
                        Add
                    </v-btn>
                </v-card-text>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    
                    <v-btn
                        color="green darken-1"
                        text
                        @click="boxSave()"

                    >
                        Guardar
                    </v-btn>
                    <v-btn
                        color="gray darken-1"
                        text
                        @click="dialogBox = false"
                    >
                        Cancelar
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>
<script setup>
    import { ref, watch } from 'vue'
    import { StreamBarcodeReader } from "vue-barcode-reader";
    import store from '@/store';

    const emits = defineEmits(['boxSave'])
    const dialogBox = ref(false)
    const dataProducts = ref([])

    const headers = ref([
        {
            text: 'Codigo barra',
            value: 'text'
        },
        {
            text: 'Alto',
            value: 'height'
        },
        {
            text: 'Ancho',
            value: 'width'
        }
    ])

    const codeBar = ref(false)

    const arraySamples = ref([])
    const arrayCodes = ref([])
    const arrayCodesBackup = ref([])

    const modeBox = ref(0)

    const boxWidth = ref(13)
    const boxHeight = ref(0)
    const boxLong = ref(13)
    const boxWeight = ref(0)

    watch( dialogBox , (newV) => {
        codeBar.value = false
    })

    function onDecode(text) {
        console.log(text)
        arraySamples.value.push(text)
        if(arraySamples.value.length >= 2) {
            if(arraySamples.value[0] == arraySamples.value[1] ) {
                console.log("muestra: ", arraySamples.value[0])
                let split = arraySamples.value[0].split('-')
                if(split.length == 4) {
                    let index = arrayCodes.value.findIndex(item => item.text == arraySamples.value[0] )
                    let indexBackup = -1
                    arrayCodesBackup.value.forEach(box => {
                        indexBackup = box.findIndex(item => item.text == arraySamples.value[0])
                        if(indexBackup != -1)
                            return
                    })

                    if( index == -1 && indexBackup == -1) {

                        let text = arraySamples.value[0]
                        let orderNumber = split[0]
                        let orderProduction = split[1]
                        let numberLine = split[2]
                        let quantityLine = split[3]

                        //validar si el codigo de barras pertenece al cliente

                        let indexDataProduct = dataProducts.value.findIndex(itemValue => itemValue.orderNumber == orderNumber)
                        console.log("indexDataProduct: ", indexDataProduct)

                        if(indexDataProduct == -1) {
                            store.dispatch('openModal', {
                                title: "Package",
                                body: "El codigo de barras no pertenece al cliente.",
                                type: 2
                            })
                            return
                        }
                        

                         //particularity order
                        let indexProduct = dataProducts.value.findIndex(item => item.orderNumber == orderNumber)
                        if(dataProducts.value[indexProduct].width > boxHeight.value) {
                            boxHeight.value = dataProducts.value[indexProduct].width
                        }
                        if(dataProducts.value[indexProduct].weight > 0)
                            boxWeight.value += parseFloat(dataProducts.value[indexProduct].weight)
                        /* if(dataProducts.value[indexProduct].valorDeclared > 0)
                            boxDeclared.value += dataProducts.value[indexProduct].valorDeclared */
                        //El valor declarado suma por cada producto de la misma caja?
                        //El valor total declarado de la caja tambien se tiene la restriccion de 695000
                        /* if(dataProducts.value[indexProduct].valorDeclared > 0 && boxDeclared.value < 695000)
                            boxDeclared.value += dataProducts.value[indexProduct].valorDeclared
                        if(boxDeclared.value > 695000)
                            boxDeclared.value = 695000 */
                        arrayCodes.value.push({
                            text: text,
                            orderNumber: orderNumber,
                            orderProduction: orderProduction,
                            numberLine: numberLine,
                            quantityLine: quantityLine,
                            height: dataProducts.value[indexProduct].height,
                            width: dataProducts.value[indexProduct].width
                        })

                        //console.log("producto agregado: ", arrayCodes.value)

                    } else {
                        store.dispatch('openModal', {
                            title: "Package",
                            body: "El producto ya esta agregado",
                            type: 3
                        })
                        //console.log("producto ya existe")
                    }
                    
                }
                codeBar.value = false
            }
            arraySamples.value = []
        }
    }

    function onLoaded(text) {
        console.log(`Ready to start scanning barcodes`)
    }

    function openModal(items, boxesArray, mode) {
        dataProducts.value = [...items]
        
        arrayCodesBackup.value = boxesArray
        modeBox.value = mode

        boxHeight.value = ''
        boxWeight.value = 0
        if(modeBox.value == 0) {
            
            boxWidth.value= '13'
            boxLong.value = '13'
        } else {
            boxWidth.value= '20'
            boxLong.value = '20'
        }
        arrayCodes.value = []

        dialogBox.value = true

    }

    function boxSave() {
        let orderNumberRepeat = {} 
        arrayCodes.value.forEach(item => {
            orderNumberRepeat[item.orderNumber] = (orderNumberRepeat[item.orderNumber] || 0) + 1
        })

        let slug = ""
        for (const number in orderNumberRepeat) {
            slug += `${number}-${orderNumberRepeat[number]}`
        }

        boxHeight.value = boxHeight.value*100+10
        boxWidth.value = boxWidth.value
        boxLong.value = boxLong.value
        boxWeight.value = boxWeight.value.toFixed(2)
        emits('boxSave', {
            slug: slug+`--${boxHeight.value}x${boxWidth.value}x${boxLong.value}-${boxWeight.value}`,
            width: boxWidth.value,
            height: boxHeight.value,
            weight: boxWeight.value,
            //declared: boxDeclared.value,
            long: boxLong,
            orderNumberRepeat: orderNumberRepeat,
            products: [...arrayCodes.value]
        })
        dialogBox.value = false
    }

    /**
     * Fake API
     */

    const count = ref(0)
    const codigosBarras = ref([
        '388031-7654321-1-1',
        '388031-1234563-1-2',
        '388031-4654889-1-3',

        '388030-7654321-1-1',
        '388030-5467823-1-2',
        '388030-6546574-1-3',
        '388030-6548763-1-4',
        '388030-5487543-1-5',

        '388029-4678923-1-1'

    ])

    function fakeCodeBar() {
        let split = codigosBarras.value[count.value].split('-')

        //Encontrar si esa orden se encuentra en el listado

        let text = codigosBarras.value[count.value]
        let orderNumber = split[0]
        let orderProduction = split[1]
        let numberLine = split[2]
        let quantityLine = split[3]
 
        //particularity order
        let indexProduct = dataProducts.value.findIndex(item => item.orderNumber == orderNumber)
        if(dataProducts.value[indexProduct].width > boxHeight.value) {
            boxHeight.value = dataProducts.value[indexProduct].width
        }
        /* if(dataProducts.value[indexProduct].valorDeclared > 0)
            boxDeclared.value += dataProducts.value[indexProduct].valorDeclared */
        if(dataProducts.value[indexProduct].weight > 0)
            boxWeight.value += parseFloat(dataProducts.value[indexProduct].weight)

        arrayCodes.value.push({
            text: text,
            orderNumber: orderNumber,
            orderProduction: orderProduction,
            numberLine: numberLine,
            quantityLine: quantityLine,
            height: dataProducts.value[indexProduct].height,
            width: dataProducts.value[indexProduct].width,
            productName: dataProducts.value[indexProduct].productName
        })
        
        count.value++
        //console.log("valor declarado: ", boxDeclared.value)
        //console.log("dataProducts.value[indexProduct]: ", dataProducts.value[indexProduct])
        //console.log("arrayCodes: ", arrayCodes.value)
    }

    defineExpose({
        openModal
    })
</script>
<style>

</style>
